﻿// Decompiled with JetBrains decompiler
// Type: ComponentAce.Compression.Libs.zlib.Tree
// Assembly: BLRCrashReporter, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: C4DCEFA4-04D9-4613-B271-9E50BDA5C72F
// Assembly location: C:\Users\SuperEwald\Downloads\depotdownloader-2.3.6\depots\209871\2520205\Blacklight Retribution\Live\Binaries\Win32\BLRCrashReporter.exe

using System;

namespace ComponentAce.Compression.Libs.zlib
{
  internal sealed class Tree
  {
    private const int MAX_BITS = 15;
    private const int BL_CODES = 19;
    private const int D_CODES = 30;
    private const int LITERALS = 256;
    private const int LENGTH_CODES = 29;
    internal const int MAX_BL_BITS = 7;
    internal const int END_BLOCK = 256;
    internal const int REP_3_6 = 16;
    internal const int REPZ_3_10 = 17;
    internal const int REPZ_11_138 = 18;
    internal const int Buf_size = 16;
    internal const int DIST_CODE_LEN = 512;
    private static readonly int L_CODES = 286;
    private static readonly int HEAP_SIZE = 2 * Tree.L_CODES + 1;
    internal static readonly int[] extra_lbits = new int[29]
    {
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      1,
      1,
      1,
      2,
      2,
      2,
      2,
      3,
      3,
      3,
      3,
      4,
      4,
      4,
      4,
      5,
      5,
      5,
      5,
      0
    };
    internal static readonly int[] extra_dbits = new int[30]
    {
      0,
      0,
      0,
      0,
      1,
      1,
      2,
      2,
      3,
      3,
      4,
      4,
      5,
      5,
      6,
      6,
      7,
      7,
      8,
      8,
      9,
      9,
      10,
      10,
      11,
      11,
      12,
      12,
      13,
      13
    };
    internal static readonly int[] extra_blbits = new int[19]
    {
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      2,
      3,
      7
    };
    internal static readonly byte[] bl_order = new byte[19]
    {
      (byte) 16,
      (byte) 17,
      (byte) 18,
      (byte) 0,
      (byte) 8,
      (byte) 7,
      (byte) 9,
      (byte) 6,
      (byte) 10,
      (byte) 5,
      (byte) 11,
      (byte) 4,
      (byte) 12,
      (byte) 3,
      (byte) 13,
      (byte) 2,
      (byte) 14,
      (byte) 1,
      (byte) 15
    };
    internal static readonly byte[] _dist_code = new byte[512]
    {
      (byte) 0,
      (byte) 1,
      (byte) 2,
      (byte) 3,
      (byte) 4,
      (byte) 4,
      (byte) 5,
      (byte) 5,
      (byte) 6,
      (byte) 6,
      (byte) 6,
      (byte) 6,
      (byte) 7,
      (byte) 7,
      (byte) 7,
      (byte) 7,
      (byte) 8,
      (byte) 8,
      (byte) 8,
      (byte) 8,
      (byte) 8,
      (byte) 8,
      (byte) 8,
      (byte) 8,
      (byte) 9,
      (byte) 9,
      (byte) 9,
      (byte) 9,
      (byte) 9,
      (byte) 9,
      (byte) 9,
      (byte) 9,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 10,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 11,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 0,
      (byte) 0,
      (byte) 16,
      (byte) 17,
      (byte) 18,
      (byte) 18,
      (byte) 19,
      (byte) 19,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 28,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29,
      (byte) 29
    };
    internal static readonly byte[] _length_code = new byte[256]
    {
      (byte) 0,
      (byte) 1,
      (byte) 2,
      (byte) 3,
      (byte) 4,
      (byte) 5,
      (byte) 6,
      (byte) 7,
      (byte) 8,
      (byte) 8,
      (byte) 9,
      (byte) 9,
      (byte) 10,
      (byte) 10,
      (byte) 11,
      (byte) 11,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 12,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 13,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 14,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 15,
      (byte) 16,
      (byte) 16,
      (byte) 16,
      (byte) 16,
      (byte) 16,
      (byte) 16,
      (byte) 16,
      (byte) 16,
      (byte) 17,
      (byte) 17,
      (byte) 17,
      (byte) 17,
      (byte) 17,
      (byte) 17,
      (byte) 17,
      (byte) 17,
      (byte) 18,
      (byte) 18,
      (byte) 18,
      (byte) 18,
      (byte) 18,
      (byte) 18,
      (byte) 18,
      (byte) 18,
      (byte) 19,
      (byte) 19,
      (byte) 19,
      (byte) 19,
      (byte) 19,
      (byte) 19,
      (byte) 19,
      (byte) 19,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 20,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 21,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 22,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 23,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 24,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 25,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 26,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 27,
      (byte) 28
    };
    internal static readonly int[] base_length = new int[29]
    {
      0,
      1,
      2,
      3,
      4,
      5,
      6,
      7,
      8,
      10,
      12,
      14,
      16,
      20,
      24,
      28,
      32,
      40,
      48,
      56,
      64,
      80,
      96,
      112,
      128,
      160,
      192,
      224,
      0
    };
    internal static readonly int[] base_dist = new int[30]
    {
      0,
      1,
      2,
      3,
      4,
      6,
      8,
      12,
      16,
      24,
      32,
      48,
      64,
      96,
      128,
      192,
      256,
      384,
      512,
      768,
      1024,
      1536,
      2048,
      3072,
      4096,
      6144,
      8192,
      12288,
      16384,
      24576
    };
    internal short[] dyn_tree;
    internal int max_code;
    internal StaticTree stat_desc;

    internal static int d_code(int dist) => dist >= 256 ? (int) Tree._dist_code[256 + SupportClass.URShift(dist, 7)] : (int) Tree._dist_code[dist];

    internal void gen_bitlen(Deflate s)
    {
      short[] dynTree = this.dyn_tree;
      short[] staticTree = this.stat_desc.static_tree;
      int[] extraBits = this.stat_desc.extra_bits;
      int extraBase = this.stat_desc.extra_base;
      int maxLength = this.stat_desc.max_length;
      int num1 = 0;
      for (int index = 0; index <= 15; ++index)
        s.bl_count[index] = (short) 0;
      dynTree[s.heap[s.heap_max] * 2 + 1] = (short) 0;
      int index1;
      for (index1 = s.heap_max + 1; index1 < Tree.HEAP_SIZE; ++index1)
      {
        int num2 = s.heap[index1];
        int index2 = (int) dynTree[(int) dynTree[num2 * 2 + 1] * 2 + 1] + 1;
        if (index2 > maxLength)
        {
          index2 = maxLength;
          ++num1;
        }
        dynTree[num2 * 2 + 1] = (short) index2;
        if (num2 <= this.max_code)
        {
          ++s.bl_count[index2];
          int num3 = 0;
          if (num2 >= extraBase)
            num3 = extraBits[num2 - extraBase];
          short num4 = dynTree[num2 * 2];
          s.opt_len += (int) num4 * (index2 + num3);
          if (staticTree != null)
            s.static_len += (int) num4 * ((int) staticTree[num2 * 2 + 1] + num3);
        }
      }
      if (num1 == 0)
        return;
      do
      {
        int index2 = maxLength - 1;
        while (s.bl_count[index2] == (short) 0)
          --index2;
        --s.bl_count[index2];
        s.bl_count[index2 + 1] = (short) ((int) s.bl_count[index2 + 1] + 2);
        --s.bl_count[maxLength];
        num1 -= 2;
      }
      while (num1 > 0);
      for (int index2 = maxLength; index2 != 0; --index2)
      {
        int num2 = (int) s.bl_count[index2];
        while (num2 != 0)
        {
          int num3 = s.heap[--index1];
          if (num3 <= this.max_code)
          {
            if ((int) dynTree[num3 * 2 + 1] != index2)
            {
              s.opt_len = (int) ((long) s.opt_len + ((long) index2 - (long) dynTree[num3 * 2 + 1]) * (long) dynTree[num3 * 2]);
              dynTree[num3 * 2 + 1] = (short) index2;
            }
            --num2;
          }
        }
      }
    }

    internal void build_tree(Deflate s)
    {
      short[] dynTree = this.dyn_tree;
      short[] staticTree = this.stat_desc.static_tree;
      int elems = this.stat_desc.elems;
      int max_code = -1;
      s.heap_len = 0;
      s.heap_max = Tree.HEAP_SIZE;
      for (int index = 0; index < elems; ++index)
      {
        if (dynTree[index * 2] != (short) 0)
        {
          s.heap[++s.heap_len] = max_code = index;
          s.depth[index] = (byte) 0;
        }
        else
          dynTree[index * 2 + 1] = (short) 0;
      }
      while (s.heap_len < 2)
      {
        int[] heap = s.heap;
        int index1 = ++s.heap_len;
        int num1;
        if (max_code >= 2)
          num1 = 0;
        else
          max_code = num1 = max_code + 1;
        int num2 = num1;
        heap[index1] = num1;
        int index2 = num2;
        dynTree[index2 * 2] = (short) 1;
        s.depth[index2] = (byte) 0;
        --s.opt_len;
        if (staticTree != null)
          s.static_len -= (int) staticTree[index2 * 2 + 1];
      }
      this.max_code = max_code;
      for (int k = s.heap_len / 2; k >= 1; --k)
        s.pqdownheap(dynTree, k);
      int index3 = elems;
      do
      {
        int index1 = s.heap[1];
        s.heap[1] = s.heap[s.heap_len--];
        s.pqdownheap(dynTree, 1);
        int index2 = s.heap[1];
        s.heap[--s.heap_max] = index1;
        s.heap[--s.heap_max] = index2;
        dynTree[index3 * 2] = (short) ((int) dynTree[index1 * 2] + (int) dynTree[index2 * 2]);
        s.depth[index3] = (byte) ((uint) Math.Max(s.depth[index1], s.depth[index2]) + 1U);
        dynTree[index1 * 2 + 1] = dynTree[index2 * 2 + 1] = (short) index3;
        s.heap[1] = index3++;
        s.pqdownheap(dynTree, 1);
      }
      while (s.heap_len >= 2);
      s.heap[--s.heap_max] = s.heap[1];
      this.gen_bitlen(s);
      Tree.gen_codes(dynTree, max_code, s.bl_count);
    }

    internal static void gen_codes(short[] tree, int max_code, short[] bl_count)
    {
      short[] numArray = new short[16];
      short num = 0;
      for (int index = 1; index <= 15; ++index)
        numArray[index] = num = (short) ((int) num + (int) bl_count[index - 1] << 1);
      for (int index = 0; index <= max_code; ++index)
      {
        int len = (int) tree[index * 2 + 1];
        if (len != 0)
          tree[index * 2] = (short) Tree.bi_reverse((int) numArray[len]++, len);
      }
    }

    internal static int bi_reverse(int code, int len)
    {
      int number = 0;
      do
      {
        int num = number | code & 1;
        code = SupportClass.URShift(code, 1);
        number = num << 1;
      }
      while (--len > 0);
      return SupportClass.URShift(number, 1);
    }
  }
}
